# -*- coding: utf-8 -*-
from setuphelpers import *
import json


bin_contains = "OpenJDK8U"
bin_type = "jre"


def update_package():
    # Declaring local variables
    arch = control.architecture
    result = False
    proxies = get_proxies()

    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    # api : https://api.adoptium.net/q/swagger-ui/#/Assets/searchReleases
    url_api_64 = "https://api.adoptium.net/v3/assets/feature_releases/8/ga?architecture=x64&heap_size=normal&image_type=jre&jvm_impl=hotspot&os=mac&page=0&page_size=10&project=jdk&sort_method=DEFAULT&sort_order=DESC&vendor=eclipse"

    # Getting latest version information from official sources
    print("API used is: %s" % url_api_64)
    json_load = json.loads(wgets(url_api_64, proxies=proxies))

    # getting  latest 64 bit version
    found = False

    for releases in json_load:
        if found:
            break
        for version in releases["binaries"]:
            if (
                bin_contains.lower() in version["installer"]["link"].lower()
                and version["image_type"].lower() == bin_type.lower()
                and version["architecture"].lower() == "x64"
                and version["installer"]["link"].endswith(".pkg")
            ):
                version_64 = (
                    version["scm_ref"].replace("v", "").replace("+", ".").replace("jdk", "").replace("u", ".0.").replace("-b", ".").split("_")[0]
                )
                url_dl_64 = version["installer"]["link"]
                latest_bin_64 = url_dl_64.rsplit("/", 1)[1]
                found = True
                version = version_64
                break

    version = version_64
    #

    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL  for x64 is: %s" % url_dl_64)
    # Downloading latest 64 bit binaries
    if not isfile(latest_bin_64):
        if arch == "all" or arch == "x64":
            print("Downloading: %s" % latest_bin_64)
            wget(url_dl_64, latest_bin_64, proxies=proxies)

    # Changing binary version for outdated binaries remove
    os.rename(latest_bin_64, bin_contains + f"-{bin_type}-" + version + ".pkg")

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating update-package-sources
    return result
